def Depth_First_Search(GG):
# Name: Patrick Coen
#Description: Incomplete Code for SA403 Final. Examines whether or not a graph is connected, and returns a list of function times.
#Input:         GG = Digraph
#Output:        Graph_Connected: Integer value (1 = Connected, 2 = Not Connected)
#               finish_time: vector of finish times for the SCC algorithm

# NOTES
# This code is modified from my submission for the Depth_First_Search algorithm. To note, my submission for the Depth_First_Search HW dependend on help I received from 2/C Shires. As a result, this submission has been assisted (indirecrtly) by 2/C Shires.
# "colors:"   0 = unvisited, 1 = currently visiting, 2 = have been visited
# "Graph_Connected:"  0 = initial value, 1 = connected, 2 = not connected

    vertNum = GG.order();              # vertNum is an integer = number of vertices in graph
    adjMat = GG.adjacency_matrix();    # adjMat = adjacency matrix of input graph H
    color = matrix(1,vertNum);          # color is the vector holding assigned color values for vertices. To start, it is all zeroes.
    startVert = 0;                    # chosen arbitrarily
    run_steps = 0;                    # run_steps will be the value we add to finish_time; for now, it is 0.
    Graph_Connected = 0;             
    finish_time = matrix(1,vertNum);  # finish_time is the vector holding all of the assigned finish times - its size is number of vertices, initially all 0

    def Depth_First_Search_Visit(v0):
        color[0,v0] = 1;             # We examine the start_vertex, and declared it "currently visiting", or 1
        for counter in xrange(0,vertNum):  # Runs loop for every vertex in the graph
            if(adjMat[v0,counter] == 1):   # If counter_vertex (one we are examining) is adjacent to the initial vertex...
                if(color[0,counter] == 0): # ...and has "color" 0,
                    Depth_FirstSearch_Visit(counter);     # Loops back through 
                #end if unvisited
            #end if adjacent
        #end for all vertices
        color[0,v0] = 2;              #If there are no remaining vertices adjacent to c with "color" 0, give vertex c "color" 2.
    

    Depth_First_Search_Visit(startVert);           
    for c in xrange(0,vertNum):    
        if(color[0,c] != 2):       
            Graph_Connected = 2;
            return (Graph_Connected, finish_times)          # If not all of the vertices have been visited (i.e., color=2), then the graph returns "false"
    Graph_Connected = 1;
    return (Graph_Connected, finish_times)                   #Otherwise, function returns true



def Random_Digraph(n,p):
    GG = digraphs.RandomDirectedGNP(n,p,loops=False)
    return GG

def Reverse_Digraph(G):
    G_Reverse = G.reverse()
    return G_Reverse

def Order_List(list):
    length = len(list);
    ordered_list = [0]*length;
    L = [i[0] for i in sorted(enumerate(list), key=lambda x:x[1])]
    for i in range(0,length):
        j = L[i]
        ordered_list[i] = list[j]
    return ordered_list

def Reverse_list(list):
    length = len(list);
    for i in range(0,length)
        j = length - i
        reverse_list[j] = list[i]
    return reverse_list